var fs = require('fs');

var express = require('express');
var app = express();

var port = (process.env.PORT || convertFromTextToPhoneNumber('BOOKS')) || 3000;
var pS

function convertFromTextToPhoneNumber(str) {
    str = str.toUpperCase()
    var num = ''

    str.split('').forEach(function(char, i) {
        if (
            char === 'A' || 
            char === 'B' || 
            char === 'C'
        ) num += '2'
        if (
            char === 'D' || 
            char === 'E' || 
            char === 'F'
        ) num += '3'
        if (
            char === 'G' || 
            char === 'H' || 
            char === 'I'
        ) num += '4'
        if (
            char === 'J' || 
            char === 'K' || 
            char === 'L'
        ) num += '5'
        if (
            char === 'M' || 
            char === 'N' || 
            char === 'O'
        ) num += '6'
        if (
            char === 'P' || 
            char === 'Q' || 
            char === 'Q' || 
            char === 'S'
        ) num += '7'
        if (
            char === 'T' || 
            char === 'U' || 
            char === 'V'
        ) num += '8'
        if (
            char === 'W' || 
            char === 'X' || 
            char === 'Y' || 
            char === 'Z'
        ) num += '9'
    })
    return parseInt(num)
}

pS = ['/', '/notebooks', '/notebooks']

pS.forEach(function(p, i) {
    app.get(p, function(req, res) {
        var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')
    
        var notebooks = fs.readdirSync(`${__dirname}/notebooks`)
        notebooks.forEach(function(n, i) {
            notebooks[i] = `<li class="notebook">
    <a class="notebook__link" href="/notebooks/${n}">${n}</a>
</li>`
        })
        notebooks.join('')
    
        var contents = `<ul class="notebooks">
    ${notebooks}
</ul>`
    
        html = html.replace('<pageTitle />', 'My Notebooks')
        html = html.replace('<docTitle />', 'My Notebooks')
        html = html.replace('<span editText></span>', `<a href="/create-notebook">(Create)</a>`)
        html = html.replace('<slot />', contents)
        res.send(html)
    })
})

var notebooksPath = 'notebooks'
app.get(`/${notebooksPath}/:notebook`, function(req, res) {
    var notebook = req.path.split(`/${notebooksPath}/`)[1]
    if (notebook.endsWith('/')) notebook = notebook.slice(0, -1)
    if (notebook.includes('/')) notebook = notebook.split('/')[0]
    notebook = decodeURIComponent(notebook)

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')

    var folders = fs.readdirSync(`${__dirname}/${notebooksPath}/${notebook}`)
    folders.forEach(function(f, i) {
        folders[i] = `<li class="notebook">
<a class="notebook__link" href="/notebooks/${notebook}/${f}">${f}</a>
</li>`
    })
    folders = `<ul class="notebooks">
    ${folders.join('')}
</ul>`
    

    html = html.replace('<pageTitle />', `<a href="/notebooks">Notebooks</a> > ${notebook}`)
    html = html.replace('<span editText></span>', `<span editText>
    <a href="/notebooks/${notebook}/create-folder">(Create)</a>&nbsp;<a href="/notebooks/${notebook}/delete">(Delete)</a>
</span>`)
    html = html.replace('<docTitle />', notebook)
    html = html.replace('<slot />', folders)
    res.send(html)
})

app.get(`/${notebooksPath}/:notebook/:folder`, function(req, res) {
    var page = req.path.split(`/${notebooksPath}/`)[1]
    var notebook = page.split('/')[0]
    notebook = decodeURIComponent(notebook)
    var folder = page.split('/')[1]
    folder = decodeURIComponent(folder)

    if (folder === 'create-folder') {
        isCreateFolder(req, res)
        return
    }
    else if (folder === 'createFolder') {
        createFolder(req, res)
        return
    }
    else if (folder === 'delete') {
        deleteNotebook(req, res)
        return
    }

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')

    var pages = fs.readdirSync(`${__dirname}/${notebooksPath}/${notebook}/${folder}`)
    pages.forEach(function(p, i) {
        pages[i] = `<li class="notebook">
<a class="notebook__link" href="/notebooks/${notebook}/${folder}/${p}/edit">${p}</a>
</li>`
    })
    pages = `<ul class="notebooks">
    ${pages.join('')}
</ul>`
    

    html = html.replace('<pageTitle />', `<a href="/notebooks">Notebooks</a> > <a href="/notebooks/${notebook}">${notebook}</a> > ${folder}`)
    html = html.replace('<span editText></span>', `<span editText>
    <a href="/notebooks/${notebook}/${folder}/create-page">(Create)</a>&nbsp;<a href="/notebooks/${notebook}/${folder}/delete">(Delete)</a>
</span>`)
    html = html.replace('<docTitle />', `${folder} | ${notebook}`)
    html = html.replace('<slot />', pages)
    res.send(html)
})

app.get(`/${notebooksPath}/:notebook/:folder/:page`, function(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)
    var folder = url.split('/')[1]
    folder = decodeURIComponent(folder)
    var page = url.split('/')[2]
    page = decodeURIComponent(page)

    if (page === 'create-page') {
        isCreatePage(req, res)
        return
    }
    else if (page === 'createPage') {
        createPage(req, res)
        return
    }
    else if (page === 'delete') {
        deleteFolder(req, res)
        return
    }

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')

    var pageContent = fs.readFileSync(`${__dirname}/${notebooksPath}/${notebook}/${folder}/${page}`, 'utf8')
    

    html = html.replace('<pageTitle />', `<a href="/notebooks">Notebooks</a> > <a href="/notebooks/${notebook}">${notebook}</a> > <a href="/notebooks/${notebook}/${folder}">${folder}</a> > ${page}`)
    html = html.replace('<span editText></span>', `<span editText>
    <a href="/notebooks/${notebook}/${folder}/${page}/edit">(Edit)</a>&nbsp;<a href="/notebooks/${notebook}/${folder}/${page}/delete">(Delete)</a>
</span>`)
    html = html.replace('<docTitle />', `${page} | ${folder} | ${notebook}`)
    html = html.replace('<slot />', `<section class="page">
    ${atob(pageContent)}
</section>`)
    res.send(html)
})

app.get(`/${notebooksPath}/:notebook/:folder/:page/edit*`, function(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)
    var folder = url.split('/')[1]
    folder = decodeURIComponent(folder)
    var page = url.split('/')[2]
    page = decodeURIComponent(page)

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')

    var pageContent = fs.readFileSync(`${__dirname}/${notebooksPath}/${notebook}/${folder}/${page}`, 'utf8')

    html = html.replace('</head>', `    <script src="https://cdn.tiny.cloud/1/qe1yig5tgvcqpzeeabwqce18y6ids1owccr5y6ief739ddhq/tinymce/7/tinymce.min.js" referrerpolicy="origin"></script>
    </head>`)
    html = html.replace('<pageTitle />', `Editing "<a href="/notebooks">Notebooks</a> > <a href="/notebooks/${notebook}">${notebook}</a> > <a href="/notebooks/${notebook}/${folder}">${folder}</a> > <a href="/notebooks/${notebook}/${folder}/${page}">${page}</a>"`)
    html = html.replace('<span editText></span>', `<span editText>
    <a href="/notebooks/${notebook}/${folder}/${page}">(View)</a>&nbsp;<a href="/notebooks/${notebook}/${folder}/${page}/delete">(Delete)</a>
</span>`)
    html = html.replace('<docTitle />', `Editing "${page} | ${folder} | ${notebook}"`)
    html = html.replace('<slot />', `<textarea class="edit">${atob(pageContent)}</textarea>
<script src="/js/edit.js"></script>`)
    res.send(html)
})

app.get(`/${notebooksPath}/:notebook/:folder/:page/delete*`, function(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)
    var folder = url.split('/')[1]
    folder = decodeURIComponent(folder)
    var page = url.split('/')[2]
    page = decodeURIComponent(page)

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')

    fs.unlinkSync(`${__dirname}/${notebooksPath}/${notebook}/${folder}/${page}`)

    res.redirect(`/${notebooksPath}/${notebook}/${folder}`)
})

app.get(`/${notebooksPath}/:notebook/:folder/:page/update*`, function(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]

    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)

    var folder = url.split('/')[1]
    folder = decodeURIComponent(folder)
    
    var page = url.split('/')[2]
    page = decodeURIComponent(page)
    
    var content = decodeURIComponent(atob(req.query.c))

    fs.writeFileSync(`${__dirname}/${notebooksPath}/${notebook}/${folder}/${page}`, btoa(content))
    res.send(content)
})

app.get(`/create-notebook`, function(req, res) {
    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')
    html = html.replace('<pageTitle />', `Create a Notebook`)
    html = html.replace('<docTitle />', `Create a Notebook`)
    html = html.replace('<slot />', `<div class="create-area"><input class="name" placeholder="Notebook Name">&nbsp;<button class="create">Create</button></div>
<script src="/js/createNotebook.js"></script>`)
    res.send(html)
})

app.get('/createNotebook', function(req, res) {
    var n = atob(req.query.n)
    if (!fs.existsSync(`${__dirname}/${notebooksPath}/${n}`)) fs.mkdirSync(`${__dirname}/${notebooksPath}/${n}`)
    res.send(n)
})

function isCreateFolder(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')
    html = html.replace('<pageTitle />', `Create a Folder in "${notebook}".`)
    html = html.replace('<docTitle />', `Create a Folder in "${notebook}".`)
    html = html.replace('<slot />', `<div class="create-area"><input class="name" placeholder="Folder Name">&nbsp;<button class="create">Create</button></div>
<script src="/js/createFolder.js"></script>`)
    res.send(html)
}

function createFolder(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var n = url.split('/')[0]
    n = decodeURIComponent(n)
    var f = atob(req.query.f)
    if (!fs.existsSync(`${__dirname}/${notebooksPath}/${n}/${f}`)) fs.mkdirSync(`${__dirname}/${notebooksPath}/${n}/${f}`)
    res.send(f)
}

function isCreatePage(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]

    var notebook = url.split('/')[0]
    notebook = decodeURIComponent(notebook)

    var folder = url.split('/')[1]
    folder = decodeURIComponent(folder)

    var html = fs.readFileSync(`${__dirname}/template.html`, 'utf8')
    html = html.replace('<pageTitle />', `Create a Page in "${notebook} > ${folder}".`)
    html = html.replace('<docTitle />', `Create a Page in "${notebook} ? ${folder}".`)
    html = html.replace('<slot />', `<div class="create-area"><input class="name" placeholder="Page Name">&nbsp;<button class="create">Create</button></div>
<script src="/js/createPage.js"></script>`)
    res.send(html)
}

function createPage(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var n = url.split('/')[0]
    n = decodeURIComponent(n)
    var f = url.split('/')[1]
    f = decodeURIComponent(f)
    var p = atob(req.query.p)
    if (!fs.existsSync(`${__dirname}/${notebooksPath}/${n}/${f}/${p}`)) fs.writeFileSync(`${__dirname}/${notebooksPath}/${n}/${f}/${p}`, '')
    res.send(p)
}

function deleteFolder(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var n = url.split('/')[0]
    n = decodeURIComponent(n)
    var f = url.split('/')[1]
    f = decodeURIComponent(f)
    if (fs.existsSync(`${__dirname}/${notebooksPath}/${n}/${f}`)) fs.rmdirSync(`${__dirname}/${notebooksPath}/${n}/${f}`)
    res.redirect(`/${notebooksPath}/${n}`)
}

function deleteNotebook(req, res) {
    var url = req.path.split(`/${notebooksPath}/`)[1]
    var n = url.split('/')[0]
    n = decodeURIComponent(n)
    if (fs.existsSync(`${__dirname}/${notebooksPath}/${n}`)) fs.rmdirSync(`${__dirname}/${notebooksPath}/${n}`)
    res.redirect(`/${notebooksPath}`)
}

app.use(express.static(`${__dirname}/static`))

app.listen(port, function() {
    console.log(`Open http://localhost:${port} to view the app.`);
})