tinymce.init({
    selector: '.edit', 
    // inline: true,
    resize: false, 
    plugins: [
      'link', 'image', 'lists', 'anchor', 'media', 'table', 'emoticons',     
      'preview', 'pagebreak', 'fullscreen', 
  
      'autolink', 
      'searchreplace', 'wordcount', 
      'visualblocks', 'visualchars', 'code', 
      'insertdatetime', 
      'help'
    ], 
    content_styles: `.nb-logo {
  background-image: url('https://nodejs.org/static/logos/jsIconGreen.svg');
  background-size: cover;
  background-clip: text;
  background-position: center;
  color: transparent;
}`, 
    placeholder: 'Type here...', 
    setup: (editor) => {
      editor.on('change', () => {
        editorChange(editor);
      });
    }
  });
  
  

var notebooksPath = 'notebooks'

var url = location.pathname.split(`/${notebooksPath}/`)[1]
var notebook = url
if (notebook.includes('/')) notebook = notebook.split('/')[0]
notebook = decodeURIComponent(notebook)

var folder = url
if (folder.includes('/')) folder = folder.split('/')[1]
folder = decodeURIComponent(folder)

var page = url
if (page.includes('/')) page = page.split('/')[2]
page = decodeURIComponent(page)

var textarea = document.querySelector('textarea.edit')

function editorChange(e) {
    var value = tinymce.activeEditor.getContent();

    var xhr = new XMLHttpRequest()
    xhr.open('GET', `/${notebooksPath}/${notebook}/${folder}/${page}/update?c=${btoa(encodeURIComponent(value))}`)
    xhr.addEventListener('load', function() {
      textarea.value = this.responseText
    })
    xhr.send()
}